---
title: "Bitwarden"
date: 2023-01-11T18:09:37+03:00
description: >
  Bitwarden is a self-hosted password manager.
---

{{% pageinfo %}}
This article is a stub. More information will be added soon.
{{% /pageinfo %}}

## Setting an admin token manually

First, make sure your system config is up to date. You may click "upgrade server" in the app and wait for a couple of minutes, or run the following command in the terminal:

```bash
cd /etc/nixos
git pull
```

Then, we have to generate an admin token. Run the following:

```bash
nix-shell -p openssl --run 'openssl rand -base64 48'
```

It will output a string like this:

```
47pFSgYBbS0G0vCG63nX1yyblzgNaqZ40bNuJnwq2hvOy8ABfe+iHRfBeXlfrRdJ
```

This will be a password to your admin account. Copy it and paste it somewhere safe. To set it, we will run the following, replacing `PASSWORD` with the password you just generated:

```bash
jq '.bitwarden.adminToken = "PASSWORD"' /etc/nixos/userdata/userdata.json > /etc/nixos/userdata/userdata.json.new && mv /etc/nixos/userdata/userdata.json.new /etc/nixos/userdata/userdata.json
```

Now, we have to apply the changes:

```bash
nixos-rebuild switch
```

And after rebuilding the system, restart Bitwarden:

```bash
systemctl restart vaultwarden
```

Now, your admin interface is available on `https://password.YOUR.DOMAIN/admin`.
